#include "Camera.h"

Camera::Camera(Ponto &foco, Vetor &v, Vetor &n){
	v = v.ortogonal(n);//parte de v ortogonal a n
	Vetor u = v/n;//u  ortogonal a n e v
	//normalizando os vetores
	u.normalizar();
	v.normalizar();
	n.normalizar();
	this->setFoco(foco);
	this->setU(u);
	this->setV(v);
	this->setN(n);
	//criando a matriz de mudana de base
	this->mudancaBase = Matriz(u,v,n);
}

Camera::Camera()
{
}

Camera::~Camera(void)
{
}

Ponto Camera::getFoco(){
	return this->foco;
}

Vetor Camera::getU(){
	return this->u;
}

Vetor Camera::getV(){
	return this->v;
}

Vetor Camera::getN(){
	return this->n;
}

void Camera::setFoco(Ponto& v){
	this->foco = v;
}

void Camera::setU(Vetor& v){
	this->u = v;
}

void Camera::setV(Vetor& v){
	this->v = v;
}

void Camera::setN(Vetor& v){
	this->n = v;
}

Ponto Camera::coordenadasVista(Ponto& p){
	Vetor w = p-this->foco;
	Vetor retorno = this->mudancaBase*w;
	return Ponto(retorno.getX(), retorno.getY(), retorno.getZ());
}