#include "Iluminacao.h"
#include "Math.h"


Iluminacao::Iluminacao(void)
{
	compAmbiental = Vetor(0,0,0);
	compDifusa = Vetor(0,0,0);
	somatorio = Vetor(0,0,0);
	compEspecular = Vetor(0,0,0);
	v = Vetor(0,0,0);
	normal = Vetor(0,0,0);
	pReal = Ponto(0,0,0);
}

Iluminacao::~Iluminacao(void)
{
}

Vetor Iluminacao::calculaIluminacao(Vetor& ia, double& ka, Vetor& il, Vetor& kd, Vetor& od, double& ks, double& rugosidade, Ponto& pl) {
	Vetor nulo(0,0,0);
	Vetor luz = pl - this->pReal; //vetor direcao da luz
    this->compAmbiental = ia * ka;  //componente ambiental
    this->v.normalizar();//normaliza V
    this->normal.normalizar();//normaliza N
	luz.normalizar();//normaliza L
        
    double teste = this->v * this->normal;// produto interno ALTEREI AQUI
    if(teste < 0){
		this->normal = this->normal * -1; //multiplicao por escalar ALTEREI AQUI
    }
	double prodInt = this->normal * luz;//produto Interno entre a luz e normal do pto         aqui

    if(prodInt < 0){
        this->compDifusa = nulo;   //arruda tem que zerar este danados ALTEREI AQUI
		this->compEspecular = nulo;  //zera esse tbem     ALTEREI AQUI
	}else{
		Vetor r = (this->normal *(2 * prodInt)) - luz;//vetor r, ver a22q5
		r.normalizar();

		this->compDifusa = ((kd & od)& il) * prodInt;  // componente difusa
		double temp = this->v * r;

		if(temp < 0){
			this->compEspecular = nulo; // arruda tem que colocar um valor aqui pra zerar esse troo!!!!AQUI
		}else{
			double temp2 = pow(temp, rugosidade);
			double temp3 = temp2 * ks;
 			Vetor temp4 = il * temp3;
			this->compEspecular = temp4;  //componente especular
		}
	}
    this->somatorio = this->somatorio + this->compDifusa + this->compEspecular;
    return (this->compAmbiental + this->somatorio);
}


void Iluminacao::alumeia(Vetor& coordBaric, Triangulo& tReal)
{
	this->pReal = this->pegarPontoReal(coordBaric, tReal);
	this->normal = this->pegarNormal(coordBaric, tReal);
	this->v = Ponto(0.0, 0.0, 0.0) - this->pReal;
	
}

//pegar a normal
Vetor Iluminacao::pegarNormal(Vetor& v, Triangulo& t)
{ //Normal de um ponto em funcao das normais dos vertices - a22q10

//Vetor v(this->coordBar(p, t));

Vetor n1(t.a->normal * v.getX());
Vetor n2(t.b->normal * v.getY());
Vetor n3(t.c->normal * v.getZ());


return Vetor(n1 + n2 + n3);

}


//pegar P
Ponto Iluminacao::pegarPontoReal(Vetor& v, Triangulo& t)
{ //ponto e triangulo reais

//Vetor v(this->coordBar(p, t));

Ponto p1((*t.a) *(v.getX()));
Ponto p2((*t.b) *(v.getY()));
Ponto p3((*t.c) *(v.getZ()));

return Ponto(p1 + p2 + p3);

}