#include "Ponto.h"

Ponto::Ponto(double x, double y, double z)
{
	this->setX(x);
	this->setY(y);
	this->setZ(z);
	this->normal = Vetor(0,0,0);
}

Ponto::Ponto(double x, double y)
{
	this->setX(x);
	this->setY(y);
	this->setZ(0);
	this->normal = Vetor(0,0,0);
}

Ponto::Ponto(void){
}

Ponto::~Ponto(void)
{
}

double Ponto::getX(){
	return this->x;
}

double Ponto::getY(){
	return this->y;
}

double Ponto::getZ(){
	return this->z;
}

void Ponto::setX(double p){
	this->x = p;
}

void Ponto::setY(double p){
	this->y = p;
}

void Ponto::setZ(double p){
	this->z = p;
}

Vetor Ponto::operator -(Ponto &a){
	double x = (this->getX() - a.getX());
	double y = (this->getY() - a.getY());
	double z = (this->getZ() - a.getZ());
	return Vetor(x,y,z);
}

Ponto Ponto::operator *(double c){
	return Ponto(this->getX()*c, this->getY()*c, this->getZ()*c);
}

Ponto Ponto::operator +(Ponto& p){
	return Ponto(this->getX() + p.getX(),this->getY() + p.getY(), this->getZ() + p.getZ());
}

Ponto Ponto::projetar(){
	double x = (d*this->getX())/(hx*this->getZ());
	double y = (d*this->getY())/(hy*this->getZ());
	double z = d;
	return Ponto(x,y,z);
}
