#include "TrianguloProjetado.h"

TrianguloProjetado::TrianguloProjetado(void)
{
}

TrianguloProjetado::TrianguloProjetado(Triangulo& t, Ponto& a, Ponto& b, Ponto& c){
	this->p1 = a;
	this->p2 = b;
	this->p3 = c;//setando os pontos projetados
	this->triangulo = &t;

}

TrianguloProjetado::~TrianguloProjetado(void)
{
}

void TrianguloProjetado::pintar(){
	if((this->p1.x < -1 && this->p2.x < -1 && this->p3.x < -1) ||(this->p1.x > 1 &&  this->p2.x > 1  &&  this->p3.x > 1)||(this->p1.y < -1 && this->p2.y < -1 && this->p3.y < -1)||(this->p1.y > 1 &&  this->p2.y > 1  && this->p3.y > 1)){
		return;
	}//if pra impedir de tentar pintar triangulos que tem os 3 vertices fora da tela(seria perda de tempo)
	//mesmo assim se perde tempo se o tiangulo for grande e tiver alguma parte dentor da tela
	glBegin(GL_POINTS);//para poder desenhar pontos com opengl

	//como as coordenadas vem normalizadas(entre -1 e 1), temos que multiplicar pela resoluao
	//isso vai trazer erros de aproximaao
	int x1 = this->p1.x*largura/2;
	int y1 = this->p1.y*altura/2;
	int x2 = this->p2.x*largura/2;
	int y2 = this->p2.y*altura/2;
	int x3 = this->p3.x*largura/2;
	int y3 = this->p3.y*altura/2;

	int yscan, ymax, xscan;
    double xmin, xmax, amin, amax;

	ordenar(x1, y1, x2, y2, x3, y3);

        if (y1 != y2){ //Triangulo com base inferior nao reta
            yscan = y1;
            ymax = y2;
            xscan = x1;
            xmin = x1;
            xmax = x1;

            if ((((double) (x2-x1))/(y2 - y1)) < (((double) (x3-x1))/(y3 - y1))){
                amin = (((double) (x2-x1))/(y2 - y1));
                amax = (((double) (x3-x1))/(y3 - y1));
            } else {
                amin = (((double) (x3-x1))/(y3 - y1));
                amax = (((double) (x2-x1))/(y2 - y1));
            }

            for (yscan = y1; yscan <= ymax; yscan++){
                for(xscan = (int) xmin; xscan <= xmax; xscan++){
					if(this->verificarZBuffer(xscan, yscan)){
						glVertex2d(xscan/largura + 0.5, yscan/altura + 0.5);
					}
                }
                xmin += amin;
                xmax += amax;
            }
            xmin -= amin;
            xmax -= amax;

            ymax = y3;
			yscan--;

            if ((((double) (x2-x1))/(y2 - y1)) < (((double) (x3-x1))/(y3 - y1))){
                amin = (((double) (x3-x2))/(y3 - y2));
                amax = (((double) (x3-x1))/(y3 - y1));
            } else {
                amin = (((double) (x3-x1))/(y3 - y1));
                amax = (((double) (x3-x2))/(y3 - y2));
            }
        } else {
            yscan = y1;
            ymax = y3;
            xscan = x1;
            xmin = x1;
            xmax = x2;

            amin = (((double) (x3-x1))/(y3 - y1));
            amax = (((double) (x3-x2))/(y3 - y2));
        }

        if (y2 != y3){
            for ( ; yscan <= ymax; yscan++){
                for(xscan = (int) xmin; xscan <= xmax; xscan++){
					if(this->verificarZBuffer(xscan, yscan)){
						glVertex2d(xscan/largura + 0.5, yscan/altura + 0.5);
					}
                }
                xmin += amin;
                xmax += amax;
            }
        }

        if ((y1 == y2) && (y2 == y3)){
            yscan = y1;
            for (xscan = x1; xscan <= x3; xscan++){
                if(this->verificarZBuffer(xscan, yscan)){
					glVertex2d(xscan/largura + 0.5, yscan/altura + 0.5);
				}
            }
        }
    glEnd();
}

bool TrianguloProjetado::verificarZBuffer(int& x, int& y){
	bool retorno = false;
	int m = x + largura/2;//pois x e y podem ser negativos e os indices do array nao
	int n = y + altura/2;
	Vetor coordBaric(0,0,0);
	if(m >= 0 && m < largura && n >= 0 && n < altura){//ignora os pixeis fora da tela
		coordBaric = this->combBaricentrica(Ponto(2*x/largura, 2*y/altura));
		double z = this->coordenadas(coordBaric).getZ();
		if(z >= d ){//z est na frente da camera
			if(zbuffer[m][n] == 0.0){//o buffer nao foi usado ainda pra tal pixel, pintar e star o buffer
				zbuffer[m][n] = z;
				retorno = true;
			}else if(z <= zbuffer[m][n]){//se o z a ser pintado tiver ordenada z menor que do buffer, pintar e setar o buffer
				zbuffer[m][n] = z;
				retorno = true;
			}
		}
	}
	if(retorno){//se for pra pintar, ja chama a iluminacao
		this->selecionarCor(coordBaric);
	}
	return retorno;
}

Vetor TrianguloProjetado::combBaricentrica(Ponto& p)//  s resolver aquele sistema linear
{
	double alpha, beta;
	double a2x = p1.getX() - p3.getX();//ax - cx;
    double a2y = p1.getY() - p3.getY();//ay - cy;
    double b2x = p2.getX() - p3.getX();//bx - cx;
    double b2y = p2.getY() - p3.getY();//by - cy;
    double p2x = p.getX() - p3.getX();//px - cx;
    double p2y = p.getY() - p3.getY();//py - cy;

    if (a2x != 0.0){
        if ((b2y-((b2x*a2y)/a2x)) != 0.0){
            beta = ((p2y-((p2x*a2y)/a2x))/(b2y-((b2x*a2y)/a2x)));
            alpha = ((p2x-(beta*b2x))/a2x);
        } else {
            beta = 1.0/3.0;
            alpha = ((p2x-(beta*b2x))/a2x);
        }
    } else {
        if (b2x != 0.0){
            beta = p2x/b2x;
            if (a2y != 0.0) alpha = (p2y-(beta*b2y))/a2y;
            else alpha = (1 - beta)/2.0;
        } else {
            if (a2y != 0.0){
                beta = 1.0/3.0;
                alpha = ((p2y-(beta*b2y))/a2y);
            } else if (b2y != 0.0){
                alpha = 1.0/3.0;
                beta = p2y/b2y;
            } else alpha = beta = 1.0/3.0;
        }
    }

    double gama = (1.0 - alpha - beta);
	return Vetor(alpha, beta, gama);
}

Ponto TrianguloProjetado::coordenadas(Vetor& v){//retorna o ponto real aproximado de coordenadas baricentricas projetadas v
	Ponto t1(*(triangulo->a)*(v.getX()));
	Ponto t2(*(triangulo->b)*(v.getY()));
	Ponto t3(*(triangulo->c)*(v.getZ()));

	return Ponto(t1 + t2 + t3);
}

void TrianguloProjetado::selecionarCor(Vetor& coordBaric){
	Iluminacao* i = new Iluminacao();
	i->alumeia(coordBaric, *this->triangulo);
	Vetor retorno = Vetor(0,0,0);
	for(int j = 0; j < quantidade; j++){
		retorno = i->calculaIluminacao(ia,ka,il[j],kd,od,ks,rugosidade,pl[j]);
	}
	//divide, pois os parametros sao entre zero e um
	double xCor = retorno.getX()/255.0;
	double yCor = retorno.getY()/255.0;
	double zCor = retorno.getZ()/255.0;
	glColor3d(xCor, yCor, zCor);
	delete i;
}

void TrianguloProjetado::ordenar(int& x1, int& y1, int& x2, int& y2, int& x3, int& y3){//ordena do menor y pro maior e, entao, do menor x para o maior
    int tempX, tempY;

    if(y2 > y3){
        tempX = x2;
        tempY = y2;
        x2 = x3;
        y2 = y3;
        x3 = tempX;
        y3 = tempY;
    }
    if (y1 > y2){
        tempX = x1;
        tempY = y1;
        x1 = x2;
        y1 = y2;
        x2 = tempX;
        y2 = tempY;
    } else if ((y1 == y2) && (x1 > x2)){
        tempX = x1;
        tempY = y1;
        x1 = x2;
        y1 = y2;
        x2 = tempX;
        y2 = tempY;
    }
    if(y2 > y3){
        tempX = x2;
        tempY = y2;
        x2 = x3;
        y2 = y3;
        x3 = tempX;
        y3 = tempY;
    } else if ((y2 == y3) && (x2 > x3)){
        tempX = x2;
        tempY = y2;
        x2 = x3;
        y2 = y3;
        x3 = tempX;
        y3 = tempY;
    }
    if ((y1 == y2) && (x1 > x2)){
        tempX = x1;
        tempY = y1;
        x1 = x2;
        y1 = y2;
        x2 = tempX;
        y2 = tempY;
    }
}