#pragma once
#include "Ponto.h"
#include "Triangulo.h"
#include "Vetor.h"
#include "Iluminacao.h"

#include "windows.h"
#include "GL/gl.h"
#include "glut.h"

extern double** zbuffer;

//variaveis de resoluao e camera
extern double largura;
extern double altura;
extern double d;
//variaveis de iluminaao
extern double ka;
extern Vetor ia;
extern Vetor* il;
extern Vetor kd; 
extern Vetor od; 
extern double ks;
extern double rugosidade;
extern Ponto* pl;
extern int quantidade;

class TrianguloProjetado
{
public:
	Ponto p1;
	Ponto p2;
	Ponto p3;
	Triangulo* triangulo;//ponteiro para triangulo que deu origem a este triangulo projetado

public:
	TrianguloProjetado(void);
	TrianguloProjetado(Triangulo& t, Ponto& a, Ponto& b, Ponto& c);
public:
	~TrianguloProjetado(void);
private:
	bool verificarZBuffer(int& x, int& y);//verifica o zbuffer para pintar na tela ou nao
	Ponto coordenadas(Vetor& v);//retorna o ponto real de coordenadas baricentricas v
	Vetor combBaricentrica(Ponto& pto);//encontra a combinaao baricentrica de um ponto em relaao aos pontos p1, p2, p3
	void selecionarCor(Vetor& coordBaric);//escolhe a cor a ser pintada para o pixel
	void ordenar(int& x1, int& y1, int& x2, int& y2, int& x3, int& y3);//ordenada para facilitar a pintura
public:
	void pintar();//faz tudo que inclui pintar
};
