#include "Vetor.h"
#include "math.h"

Vetor::Vetor(){
}

Vetor::Vetor(double x, double y, double z)
{
	this->setX(x);
	this->setY(y);
	this->setZ(z);
}

Vetor::~Vetor(void)
{
}

double Vetor::getX(){
	return this->coordenadas[0];
}

double Vetor::getY(){
	return this->coordenadas[1];
}

double Vetor::getZ(){
	return this->coordenadas[2];
}

void Vetor::setX(double p){
	this->coordenadas[0] = p;
}

void Vetor::setY(double p){
	this->coordenadas[1] = p;
}

void Vetor::setZ(double p){
	this->coordenadas[2] = p;
}

double Vetor::norma(){
	return sqrt((*this)*(*this));
}

double Vetor::operator *(Vetor& v){//prod interno
	double retorno = this->getX()*v.getX() + this->getY()*v.getY() + this->getZ()*v.getZ();
	return retorno;
}

Vetor Vetor::operator /(Vetor &v){
	double x = this->getY()*v.getZ() - this->getZ()*v.getY();
	double y = this->getZ()*v.getX() - this->getX()*v.getZ();
	double z = this->getX()*v.getY() - this->getY()*v.getX();
	return Vetor(x,y,z);
}

Vetor Vetor::operator +(Vetor &v){
	return Vetor(this->getX() + v.getX(),this->getY() + v.getY(), this->getZ() + v.getZ());
}

Vetor Vetor::operator -(Vetor &v){
	return Vetor(this->getX() - v.getX(),this->getY() - v.getY(), this->getZ() - v.getZ());
}

void Vetor::normalizar(){
	double norma = this->norma();
	this->setX(this->getX()/norma);
	this->setY(this->getY()/norma);
	this->setZ(this->getZ()/norma);
}

Vetor Vetor::operator *(double c){
	return Vetor(this->getX()*c, this->getY()*c, this->getZ()*c);
}

Vetor Vetor::operator &(Vetor& v){
	return Vetor(this->getX()*v.getX(), this->getY()*v.getY(), this->getZ()*v.getZ());
}

Vetor Vetor::projecao(Vetor &v){
	double c = ((*this)*v)/(v*v);
	return v*c;
}

Vetor Vetor::ortogonal(Vetor& v){
	return ((*this) - this->projecao(v));
}