#include "Camera.h"
#include "iostream"
#include "fstream"
#include "Triangulo.h"
#include "TrianguloProjetado.h"
#include "Principal.h"
#include "string"

//headers do openGL
#include "windows.h"
#include "GL/gl.h"
#include "glut.h"
using namespace std;

//variaveis globais
//resoluao
double altura = 1200;
double largura = 1600;
Principal principal;
int size;
//zbuffer
double** zbuffer;
//parametros de camera
double d;
double hx;
double hy;
//parametros de iluminacao
double ka;
Vetor ia;
Vetor* il;
Vetor kd; 
Vetor od; 
double ks;
double rugosidade;
Ponto* pl;

int quantidade;

bool atualizar = true;


void init(){
	//Seleciona a cor de fundo para limpeza da tela
	glClearColor(0, 0, 0, 0);
	//inicializa os valores de visualizao
	glMatrixMode(GL_PROJECTION);
	/* Faz com que a matriz corrente seja inicializada com a matriz identidade
	 * (nenhuma transformao  acumulada)
	 */
	glLoadIdentity();
	glOrtho(0.0, 1.0, 0.0, 1.0, -1.0, 1.0);
}

void display(void){
	//limpa o fundo da tela
	glClear (GL_COLOR_BUFFER_BIT);

	//isso daqui carrega o arquivo
	if(atualizar){
		double x;
		double y;
		double z;

		int p;
		Ponto* pontos;
		Triangulo* triangulos;
		Camera camera;

		ifstream arq("entrada.txt");
		if(arq.is_open()){
			//leitura dos parametros da camera
			arq >> x;
			arq >> y;
			arq >> z;
			Ponto foco(x,y,z);
			arq >> x;
			arq >> y;
			arq >> z;
			Vetor n(x,y,z);
			arq >> x;
			arq >> y;
			arq >> z;
			Vetor v(x,y,z);
			arq >> d;
			arq >> hx;
			arq >> hy;

			camera = Camera(foco, v, n);
			//leitura do arquivo triangulado
			//associar os triangulos aos pontos, achar as normais dos pontos em funao das dos triangulos
			std::string nome;
			arq >> nome;
			ifstream arqObjeto(nome.c_str());//arquivo do objeto triangulado
			if(arqObjeto.is_open()){
				arqObjeto >> p;
				arqObjeto >> size;
				pontos = new Ponto[p];
				triangulos = new Triangulo[size];//size  variavel global, repassada para pintar os triangulos
				int a;
				int b;
				int c;
				for(int i = 0; i < p; i++){
					arqObjeto >> x;
					arqObjeto >> y;
					arqObjeto >> z;
					//array de pontos j em coordenadas de vista
					pontos[i] = camera.coordenadasVista(Ponto(x,y,z));
				}
				for(int i = 0; i < size; i++){ 
					arqObjeto >> a;
					a--;//subtrai 1 por que a entrada vem 1 a mais XD
					arqObjeto >> b;
					b--;
					arqObjeto >> c;
					c--;
					triangulos[i] = Triangulo(pontos[a], pontos[b], pontos[c]);
					//enquanto cria os triangulos, ajeita as normais dos vertices dos tiangulos
					pontos[a].normal = pontos[a].normal + triangulos[i].normal;
					pontos[b].normal = pontos[b].normal + triangulos[i].normal;
					pontos[c].normal = pontos[c].normal + triangulos[i].normal;
				}
				for(int i = 0; i < p; i++){
					pontos[i].normal.normalizar();//normaliza as normais de cada vertice
				}
				arqObjeto.close();
			}
						
			//parametros de objeto
			arq >> ka;
			arq >> x;
			arq >> y;
			arq >> z;
			kd = Vetor(x,y,z);//arruda, pra isso que existe construtor 11!
			arq >> ks;
			arq >> x;
			arq >> y;
			arq >> z;
			od = Vetor(x,y,z);
			arq >> rugosidade;
			//parametros de iluminacao
			arq >> x;
			arq >> y;
			arq >> z;
			ia = Vetor(x,y,z);
			arq >> quantidade;
			pl = new Ponto[quantidade];
			il = new Vetor[quantidade];
			for(int i = 0; i < quantidade; i++){
				arq >> x;
				arq >> y;
				arq >> z;
				il[i] = Vetor(x,y,z);
				arq >> x;
				arq >> y;
				arq >> z;
				pl[i] = camera.coordenadasVista(Ponto(x,y,z));
			}
			arq.close();
		}
		//cria o principal
		principal = Principal(pontos, triangulos, size);
		//reseta o atualizar
		atualizar = false;
	}

	//zera o zbuffer toda vez que desenhar
	for(int i = 0; i < largura; i++){
		for(int j = 0; j < altura; j++){
			zbuffer[i][j] = 0.0;
		}
	}
	//tamanho do ponto
	glPointSize(1);
	
	for(int i = 0; i < size; i++){//pinta todos os triangulos
		principal.triangulosProjetados[i].pintar();
	}
	//?
	glFlush();

}

void keyboardEvent(int key, int x, int y){ 
	switch(key){ 
		case GLUT_KEY_F5://tecla f5
			atualizar = true;
			//deletar as coisas
			delete[] principal.triangulosProjetados;
			delete[] principal.triangulos;
			delete[] principal.pontos;
			delete[] pl;
			delete[] il;
			//repintar
			display();
			break;
	} 
}

int main(){
	//Modo de exibio
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
	//Propriedades da janela
	glutInitWindowSize (largura, altura);
	glutInitWindowPosition (0, 0);
	glutCreateWindow ("EOF");
	glutFullScreen();
	//Parmetros iniciais do OpenGL
	init();
	//inicializar o ZBuffer
	zbuffer = new double*[largura];
	for(int i = 0; i < largura; i++){
		zbuffer[i] = new double[altura];
	}
	//Associa a funo display como uma funo de callback
	glutDisplayFunc(display); 
	//mesma coisa pra keyboardEvent
	glutSpecialFunc(keyboardEvent);
	glutMainLoop();

	return 0;
}
